require_relative '../spec_helper'

describe Pokan::Cluster::PreparedString do

  let(:string) {
    'A: %p, B: %p C:%p'
  }

  let(:prepared_string) {
    Pokan::Cluster::PreparedString.new(string)
  }

  it 'should return the given string when no substitution is made' do
    prepared_string.string.should eq string
  end

  it 'should return semi substituted string' do
    prepared_string.with('dummy').string.should eq 'A: dummy, B: %p C:%p'
  end

  it 'should return fully substituted string' do
    prepared_string.with('dummy', 'yummy', 'mummy').string.should eq 'A: dummy, B: yummy C:mummy'
  end

  it 'should return correctly substituted string when more arguments are passed' do
    prepared_string.with('dummy', 'yummy', 'mummy', 'a', 'b', 'c').string.should eq 'A: dummy, B: yummy C:mummy'
  end

  it 'should return initial string after changes' do
    prepared_string.with('dummy').string.should eq 'A: dummy, B: %p C:%p'
    prepared_string.string.should eq string
  end

end
